////////////////////////////////////////////////////////////////////////////////////////////////
//
//  LICModel.fx ver1.0
//  쐬: ͉P
//  : memoblog
//
////////////////////////////////////////////////////////////////////////////////////////////////
// p[^`

// ݒp[^
// mCY臒l(0`1.0f)
float noiseCoeff = 0.9f;

// 
float time_0_X : Time;
// XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;

// @ϊs
float4x4 WorldViewMatrix      : WORLDVIEW;
float4x4 ProjMatrix           : PROJECTION;
float4x4 WorldMatrix          : WORLD;

float3   LightDirection    : DIRECTION < string Object = "Light"; >;
float3   CameraPosition    : POSITION  < string Object = "Camera"; >;

// }eAF
float4   MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;
float3   MaterialAmbient   : AMBIENT  < string Object = "Geometry"; >;
float3   MaterialEmmisive  : EMISSIVE < string Object = "Geometry"; >;
float3   MaterialSpecular  : SPECULAR < string Object = "Geometry"; >;
float    SpecularPower     : SPECULARPOWER < string Object = "Geometry"; >;
float3   MaterialToon      : TOONCOLOR;
// CgF
float3   LightDiffuse      : DIFFUSE   < string Object = "Light"; >;
float3   LightAmbient      : AMBIENT   < string Object = "Light"; >;
float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;
static float4 DiffuseColor  = MaterialDiffuse  * float4(LightDiffuse, 1.0f);
static float3 AmbientColor  = saturate(MaterialAmbient  * LightAmbient + MaterialEmmisive);
static float3 SpecularColor = MaterialSpecular * LightSpecular;

bool use_texture;  //eNX`̗L
bool use_toon;     //gD[̗L

// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state {
    texture = <ObjectTexture>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
};

// MMD{sampler㏑Ȃ߂̋LqłB폜sB
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);

// _VF[_̏o̓f[^^
struct VS_OUTPUT
{
    float4 Pos        : POSITION;    // ˉeϊW
    float2 Tex        : TEXCOORD1;   // eNX`
    float3 VecDir     : TEXCOORD2;   // xNg
    float3 Eye        : TEXCOORD3;   // JƂ̑Έʒu
    float2 screenTex  : TEXCOORD4;   // XN[W
};

///////////////////////////////////////////////////////////////////////////////////////////////
// VF[_R[h

// Vtg
int shiftLeft(int src, int shiftBit)
{
	return (double)src*pow(2.0, (double)shiftBit);
}

// EVtg
int shiftRight(int src, int shiftBit)
{
	return floor((double)src/pow(2.0, (double)shiftBit));
}

// w肵rbg̒l(0/1)擾
int getBit(int src, int bitNo)
{
  int tmp = src;
  tmp = shiftRight(src, bitNo);
  tmp = tmp%2;
  if (src < 0)
  {
    return -tmp;
  }
  return tmp;
}

// rI_ai̒lj
int XOR(int src1, int src2)
{
    int ret;
    int tmp1, tmp2, base = 1, sum=0;
    for (int i=0; i<32; i++)
    {
        tmp1 = getBit(src1, i);
        tmp2 = getBit(src2, i);
        if (tmp1 != tmp2)
        {
            sum += base;
        }
        base *= 2;
    }
    ret = sum;
    return ret;
}

// 傫Ȓl牺31rbgoint^ɕϊ
int getLowBits(float val)
{
    int base = 1, ret = 0;
    float tmp = val, tmp2;
    for (int i=0; i<31; i++)
    {
        tmp = tmp/2.0;
        modf(tmp, tmp2);
        if ((tmp-tmp2) > 0)
        {
            ret += base;
            tmp = tmp2;
        }
        base *= 2;
        if (tmp < 1.0)
        {
            break;
        }
    }
    return ret;
}

// mCY̐
float getNoise(float px, float py, float t)
{
    int n = px*ViewportSize.x*2813.1f+py*ViewportSize.y*2315.0f+t*98.7f;
    int n2 = shiftLeft(n, 3);
    int n3 = XOR(n2, n);
	int n4 = getLowBits(n3*n3+12385.9);
	return (n4/(float)0x7fffffff);
}

// _VF[_
VS_OUTPUT Basic_VS( float4 Pos : POSITION, float3 Normal : NORMAL, float2 Tex : TEXCOORD0)
{
    float4 Pos0 = Pos;
    
    // IuWFNg̍WXN[̍Wւƕϊi[hr[ˉeϊj
    Pos = mul( Pos, WorldViewMatrix );
    Pos = mul( Pos, ProjMatrix );
    
    // sNZVF[_ł̃CeBOvZpB
    // JƂ̑Έʒu
    float4 WPos = mul(Pos0, WorldMatrix);
    float3 Eye = CameraPosition - WPos.xyz/WPos.w;
    // _@
    float4 tmpN = mul(float4(Normal, 1.0), WorldMatrix);
    Normal = normalize( tmpN.rgb );
    
    // XN[W
    float2 SPos;
    SPos.x = (Pos.x / Pos.w)*0.5f+0.5f;
    SPos.y = (Pos.y / Pos.w)*0.5f+0.5f;
    
    VS_OUTPUT Out = { Pos, Tex, Normal, Eye, SPos };
    return Out;
}

// sNZVF[_
float4 Basic_PS( float2 Tex : TEXCOORD1, float3 Normal : TEXCOORD2, float3 Eye : TEXCOORD3, float2 SPos : TEXCOORD4 ) : COLOR0
{
    float4 Color = 0;
    
    // fBt[YF{ArGgF vZ
    Color.rgb = saturate( max(0,dot( Normal, -LightDirection )) * DiffuseColor.rgb + AmbientColor );
    Color.a = DiffuseColor.a;
    
    // XyLFvZ
    float3 HalfVector = normalize( normalize(Eye) + -LightDirection );
    float3 Specular = pow( max(0,dot( HalfVector, normalize(Normal) )), SpecularPower ) * SpecularColor;
    
    if ( use_texture ) {
        // eNX`KpBeNX`w肳Ăꍇ̂݁B
        Color *= tex2D( ObjTexSampler, Tex );
    }
    if ( use_toon ) {
        // gD[KpBgD[w肳Ăꍇ̂݁B
        float LightNormal = dot( Normal, -LightDirection );
        // if(LightNormal<0){Color.rgb*=MaterialToon;} ƂĂ悢AẼhbgĂ܂̂łڂ
        Color.rgb *= lerp(MaterialToon, float3(1,1,1), saturate(LightNormal * 16 + 0.5));
    }
    // XyLKp
    Color.rgb += Specular;

	// _mCY̎擾    
    float val = getNoise(0.01*Tex.y+SPos.x, 0.01*Tex.x+SPos.y, 0); // time_0_X
    // ZxlɉmCY̌vZ
    float T = noiseCoeff*(1.0-(Color.r+Color.g+Color.b)/3.0);
    if (val >= T)
    {
	    Color.b = 1;
	}
	else
	{
		Color.b = 0;
	}
	// XYxNǧvZ
    float3 up = float3(0, 1, 0);
    float3 right = cross(up, Normal);
    // XŶݕێ
    Color.rg = 0.5+0.5*cross(Normal, right).xy;
    
    return Color;
}

// eNjbN`
technique MainTec
{
    pass DrawObject
    {
        VertexShader = compile vs_3_0 Basic_VS();
        PixelShader  = compile ps_3_0 Basic_PS();
    }
}
